package model;

/**
 * Questa classe permette di distribuire un insieme di elementi in posizioni diverse nello spazio
 * In particolare attraverso il metodo <code>compute</code>  possibile ottenere una traslazione dell'oggetto
 * in base ad una distanza minima e all'indice numerico dell'oggetto.
 * L'individuazione delle posizioni  dal centro verso l'esterno
 * 
 * @author Matteo Campana nmatr.0000197228
 */
import javax.vecmath.*;
public class LayOutMaker {
	/**
	 * Metodo che calcola la Traslazione da assegnare ad un oggetto per inserirlo in una posizioneprecisa 
	 * Esoo calcola la traslazione in base alla posizione che ocupa in lista 'numElem' e
	 * in base alla distaza minima dal centro.
	 * 
	 * @param distMin Distanza dal centro(0,0,0) minima.
	 * @param numElem Posizione in lista dell'elemento
	 * @param vettore Traslazione dal centro da assegnare all'oggetto
	*/		
	public void compute(double dist, double numElem, Vector3d vettore){
		double temp = numElem;
		int i=1;
		//Calcolo "i" cio il livello(la distaza) nel quale inserire l'elemento
		//visto che ogni livello ne contiene al max 8
		if (temp>8){
			for (i=1; temp>8;i++){
				temp=temp-8;
			}
		}
		//Posiziono l'oggetto nell'angolo o posizione corretta del livello trovato
		double distMin=dist*i;
		if (temp == 0) vettore.set(0,0,0);
		if (temp == 1) vettore.set(distMin,0,distMin);
		if (temp == 2) vettore.set(-distMin,0,-distMin);
		if (temp == 3) vettore.set(-distMin,0,distMin);
		if (temp == 4) vettore.set(distMin,0,-distMin);
		if (temp == 5) vettore.set(0,0,distMin);
		if (temp == 6) vettore.set(0,0,-distMin);
		if (temp == 7) vettore.set(distMin,0,0);
		if (temp == 8) vettore.set(-distMin,0,0);
				
	}

}
