package model.visualobj;

/**
 * La classe crea un visual object estendendo la classe shape3D.
 * Il visual object  un insieme di linee che intersecate tra loro creano una griglia che poggia sull'asse X Y
 * 
 * @author Matteo User
 *
 */

import javax.media.j3d.*;
import javax.vecmath.*;

	public class Grid extends Shape3D{
		private Geometry voGeometry;
		private Appearance voAppearance;
		
		public Grid(){
			voGeometry = createGeometry();
			voAppearance = createAppearance();
			this.setGeometry(voGeometry);
			this.setAppearance(voAppearance);
		}
		
		private Geometry createGeometry(){
			
			// codice per creare la geometria dell'oggetto
			LineArray landGeom=new LineArray(44,GeometryArray.COORDINATES|GeometryArray.COLOR_3);
			float l=-50.0f;
			for (int c=0;c<44;c+=4){
		 		landGeom.setCoordinate(c+0,new Point3f(-50.0f,0.0f,l));
		  		landGeom.setCoordinate(c+1,new Point3f(50.0f,0.0f,l));
		  		landGeom.setCoordinate(c+2,new Point3f(l,0.0f,-50.0f));
		  		landGeom.setCoordinate(c+3,new Point3f(l,0.0f,50.0f));
		  		l+=10.0f;
			}
			
			Color3f c=new Color3f(0.1f,0.8f,0.1f);
			for (int i=0;i<44;i++)landGeom.setColor(i,c);
			
			return (landGeom);
		}
		
		private Appearance createAppearance(){
			LineAttributes la = new LineAttributes();
			la.setLineWidth(0.8f);
			Appearance ap = new Appearance();
			ap.setLineAttributes(la);
			return ap;
		}
		
}
