package util;

/**
 * 
 * @author Matteo Campana nmatr.0000197228
 */
import model.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.Date;
import java.lang.Math;
import java.util.*;
public class moveAgent{
	/**
	 * Thread che avvicina l'agente al tc.
	 * 
	 * @param ag Il CadObject rappresentante l'agente
	 * @param t Il CadObject rappresentante il Tuple Center
 	 * @param inList La lista degli interpolatori associati al nome dell'oggetto al quale sono collegati
	 * @param un Il CadUniverse al quale collegare o staccare elementi
	*/
	protected CadUniverse uni;
	protected CadObject agent;
	protected CadObject tc;
	protected HashMap interpList;
	protected Transform3D assex;
	double distanz;
	public moveAgent(CadUniverse un,CadObject ag,CadObject t, HashMap inList){
		uni=un;
		agent=ag;
		tc = t;
		interpList = inList;

		
		//ELIMINO EVENTUALI INTERPOLAZIONI IN CORSO
		//controllo se esiste un interpolatore associato all'agente
		if(interpList.containsKey(agent)){ 
			PositionInterpolator tempMovAg = (PositionInterpolator)interpList.get(agent);
			//elimini l'interpolatore staccando e poi riattaccando l'oggetto dalla scena
			agent.bg.detach();
			agent.tg.removeChild(tempMovAg);
			uni.BGuserobject.addChild(agent.getRoot());
			//e lo cavo dall'hash map
			interpList.remove(agent);
		}
		
		
		
		//CREO UNA NUOVA INTERPOLAZIONE PER MUOVERE L'AGENTE VERSO IL TUPLE CENTER
		//	calcolo la distanza tra i due.
		double distanza=agent.getPosition().distance(tc.getPosition());
		distanz=distanza;
		
			//Crea una trasformazione affine che mi definir l'asse dispostamento
			Transform3D xAxis= new Transform3D();
			
			//IMPOSTO LA TRASLAZIONE
			//Vector3d vetTraslaz=new Vector3d(agent.getPosition().x,agent.getPosition().y,agent.getPosition().z );
		    //Mi memorizzo la posizione attuale prima che venga modificata
			Point3f posIniziale= new Point3f(agent.getPosition());


			//CALCOLO LA ROTAZIONE SU Y DA DARE AL SISTEMA DI PARTENZA
			Matrix3d yRot= new Matrix3d();
			Vector2d avector = new Vector2d(agent.getPosition().x,agent.getPosition().z);
			Vector2d tcvector = new Vector2d(tc.getPosition().x,tc.getPosition().z);
			Vector2d diff = new Vector2d();
			diff.sub(tcvector,avector);
			

			
			//trovo l'angolo tra il vettore trovato e l'asse x (PRESO COME VETTORE (3,0))
			double angoloy = diff.angle(new Vector2d(3,0));
			
			//visto che mi da sempre angoli positivi devo sapere se fare una
			//rotazione positiva(cio da 0 a pigreco) o negativa quindi
			if (diff.y > 0){
				//Ruoto di -angoloy sull'asse y
				yRot.rotY(2*Math.PI-angoloy);
			}else{
				//Ruoto di angoloy sull'asse y
				yRot.rotY(angoloy);
			}
			
//QUESTA  UNA BOZZA DI COME REALIZZARE I MOVIMENTI DEGLI AGENTI ANCHE LUNGO LA DIREZIONE DELL'ASSE Y (verticate)			
/*
			//CALCOLO LA ROTAZIONE SU Z DA DARE AL SISTEMA DI PARTENZA
			Matrix3d zRot= new Matrix3d();
			avector = new Vector2d(agent.getPosition().x,agent.getPosition().y);
			tcvector = new Vector2d(tc.getPosition().x,tc.getPosition().y);
			Vector2d diff2 = new Vector2d();
			diff2.sub(tcvector,avector);
			
			//trovo l'angolo tra il vettore trovato e l'asse x (PRESO COME VETTORE (3,0))
			double angoloz = diff2.angle(new Vector2d(3,0));

			//debug
			System.out.println(angoloz);

			
			//visto che mi da sempre angoli positivi devo sapere se fare una
			//rotazionepositiva o negativa quindi
			if (diff2.y < 0){
				//Ruoto di -angoloy sull'asse y
				zRot.rotZ(2*Math.PI-angoloz);
			}else{
				//Ruoto di angoloy sull'asse y
				zRot.rotZ(angoloz);
			}
			
			
			Matrix3d totRot = new Matrix3d();
			totRot.mul(yRot,zRot);
*/
			xAxis.set(yRot);
			
			
			
			
			assex=xAxis;

			
			//ottengo il tempo trascorso dal lancio dell'applicazione 
			//creando un Alpha object fittizzio
			Alpha tempAlpha = new Alpha();
			Date date = new Date();
			//Calcolo il tempo trascorso dal lancio dell'applicazione fino ora
			long trigTime= date.getTime()- tempAlpha.getStartTime();


			//Creo un Alpha timer per comandare l'interpolatore
			Alpha xAlpha = new Alpha(1,trigTime,0,8000,0,0);
			
			///Crea un interpolatore per le posizioni collegato con il gruppo di trasformazione
			PositionInterpolator posInt=new PositionInterpolator(xAlpha,agent.tg,assex,0f,((float)distanz-3f));
			//Imposta un raggio d'azione all'interpolatore
			posInt.setSchedulingBounds(new BoundingSphere(new Point3d(0,0,0),2000.0));
			//aggiungo l'interpolatore alla lista degli interpolazioni presenti
			interpList.put(agent, posInt);
			
			//Stacco l'oggetto dalla scena
			agent.bg.detach();
		
			//Collego l'interpolatore al TG dell'agente
			agent.tg.addChild(posInt);
			
			//Riattacco l'oggetto alla scena
			uni.BGuserobject.addChild(agent.getRoot());
			
		
			//Imposto il tg2 dell'agente nella posizione di partenza
			//Cio mentre l'iterpolatore lavora sul tg dell'agente come se partisse dal centro(0,0,0)
			//il tg2 si setta con una traslazione fissa pari alla posizione iniziale
			//Per far questosi sono impostati i primi tre elementi della 4Colonna della matrice 
			Transform3D tras2= new Transform3D();
			Matrix4f matrix2= new Matrix4f();
			agent.tg2.getTransform(tras2);
			tras2.get(matrix2);
			matrix2.setElement(0,3,posIniziale.x);//azzero eventuali traslazioni sulla x
			matrix2.setElement(1,3,posIniziale.y);//azzero eventuali traslazioni sulla y
			matrix2.setElement(2,3,posIniziale.z);//azzero eventuali traslazioni sulla z
			tras2.set(matrix2);
			agent.tg2.setTransform(tras2);

		

//Questa era la vecchia versione per la traslazione di tg2( valida comunque)
/*
		//Azzero eventuali traslazioni rimaste
		Transform3D tras2= new Transform3D();
		Matrix4f matrix= new Matrix4f();
		agent.tg2.getTransform(tras2);
		tras2.get(matrix);
		matrix.setElement(0,3,0);//azzero eventuali traslazioni sulla x
		matrix.setElement(1,3,0);//azzero eventuali traslazioni sulla y
		matrix.setElement(2,3,0);//azzero eventuali traslazioni sulla z
		tras2.set(matrix);
		agent.tg2.setTransform(tras2);




		Transform3D tras= new Transform3D();

		System.out.println("Vet traslaz: "+vetTraslaz.toString());
		Transform3D tras1= new Transform3D();
		agent.tg2.getTransform(tras1);
		System.out.println("tras del TG2 prima: "+tras1.toString());
		
		tras.setTranslation(vetTraslaz);
		agent.tg2.setTransform(tras);
		
		agent.tg2.getTransform(tras1);
		System.out.println("tras del TG2 dopo: "+tras1.toString());
		
		System.out.println("Posiz 2: "+agent.getPosition().toString());
*/

	}	
}
