package view;

/**
 * La classe puo essere vista come l'agente che si occupa di recuperare informazioni per il monitoraggio 
 * di uno specifico nodo.
 * La classe estende la classe Thread.
 * Questo permette di avere pi agenti di questo tipo simultaneamente e con flussi di controllo separati.
 * I vari Thread(agenti) vengono lanciati da una applicazione che dovr specificare il nome del nodo da monitorare.
 *  
 * @author Matteo Campana nmatr.0000197228
 */
import model.*;
import util.*;
import javax.swing.*;
import java.awt.*;
import alice.tucson.api.*;
import alice.logictuple.*;
import alice.util.*;
import java.util.*;


public class GraficAgTCAgent extends Thread {
	protected String nodeName; //nome del nodo da monitorare
	protected HashMap listMovAgent;// una lista interna che serve a contenere gli interpolatori 
//che stanno muovendo ho hanno gi spostato l'agente relativo
//Questo serve nel momento in cui un agente e una tupla iteragiscono 
//e si vuole quindi spostare l'agente verso la TC.
//Se l'agente si sta muovendo gi verso una tupla  necessario eliminare questo movimento(interpolatore) e 
//inserire quello nuovo.
//La lista tiene quindi traccia dell'ultimo iteratore che  inervenuto o sta intervenendo sull'agente al 
//quale  associato  
	
	
  /**
   * il costruttore (eseguito ogni volta che si lancia il Thread) permette di acquisire il 
   * nome del nodo da ispezionare e inizializza la lista degli iteratori
   * 
   * @param nome Riceve il nome del nodo da monitorare
  */	
	public GraficAgTCAgent(String nome){
		nodeName = nome;
		listMovAgent= new HashMap();
	}
	
	public void run(){
		try {
			
			//Creo l'interfaccia grafica
			AgTCGui myGui= new AgTCGui();
			JFrame f = new JFrame("Monitoring node: "+ nodeName);
			f.getContentPane().add(myGui, BorderLayout.EAST);
			f.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
			f.setExtendedState(Frame.MAXIMIZED_BOTH);

			//Creo l'agente "graficAgTCAgent" nel nodo locale
			AgentId aid = new AgentId("graficAgTCAgent");
			TucsonContext cn = Tucson.enterContext(new DefaultContextDescription(aid));
			TupleCentreId tid = new TupleCentreId("'$OBS'");
		
			//Leggo dal tuple center '$OBS' la tupla agent_list(X)
			//contenente i nomi degli agenti presenti
			//LogicTuple tagent =cn.rd(tid, new LogicTuple("agent_list",new Value(Tools.removeApices(nodeName)), new Var("Y")));
			LogicTuple tagent =cn.rd(tid, new LogicTuple("agent_list", new Var("Y")));
			
			//Leggo dal tuple center '$OBS' la tupla tc_list(X)
			//contenente i nomi deglle tuple center presenti
			//LogicTuple ttc =cn.rd(tid, new LogicTuple("tc_list",new Value(Tools.removeApices(nodeName)), new Var("Z")));
			LogicTuple ttc =cn.rd(tid, new LogicTuple("tc_list", new Var("Z")));
			//Creo un Universo con i nodi presenti passandogli la lista degli agenti e tc presenti
			AgTCUniverse myUniv = new AgTCUniverse(tagent.getArg(0).toList(), ttc.getArg(0).toList(), myGui.elemSel);
			
			//Collego il mio universo con la finestra grafica e la mostro
			f.getContentPane().add(myUniv.getSimUniverse().getCanvas(), BorderLayout.CENTER);
			f.show();
			//Ora lo metto in ascolto di informazioni relative al nodo da monitorare
			LogicTuple t2;
			Tools tool = new Tools();
			moveAgent movea;
			String nomATemp;
			String nomTCTemp;
			for(;;){
				//Leggo la tupla node event
				//t2 =cn.in(tid, new LogicTuple("node_event",new Value(Tools.removeApices(nodeName)), new Var("X")));
				t2 =cn.in(tid, new LogicTuple("node_event",new Value("_"), new Var("X")));
				//aggiungo o elimino i nodi cancellando eventuali apici dai nomi
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("new_agent")){
					myUniv.addAgent(t2.getArg(1).getArg(0).toString());	
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("exit_agent")){
				myUniv.deleteAgent(t2.getArg(1).getArg(0).toString());
				//Se un agente esce si deve eliminare il riferimento di questo agente nell' interpolatorList
				//la cosa no deve essere fatta per l'arrivo di new agent; infatti la voce nella lista viene inserita
				//all'arrivo di una node_event
				String nomAg=t2.getArg(1).getArg(0).toString();
				listMovAgent.remove(nomAg);	
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("new_tc")){
					myUniv.addTC(t2.getArg(1).getArg(0).toString());	
				}
				//Vario il colore dell'agente e del Tc che sono intervenuti nell'evento
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("done_out")){
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),1f, 0f, 0f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);															
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),1f, 0f, 0f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					//Visto che non c' un metodo in AgTCUnivrse che mi ritorni il CadObject assoiato
					// necessario fare queste cose poco eleganti...Cast compreso
					//Una possibile miglioria potrebbe essere l'iplementazione di questo metodo corredato di lancio
					//dell'eccezzione nel caso in cuinon esista il CadObject specificato
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}	
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("requested_in")){
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),0f, 0f, 1f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0.8f);										
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),0f, 0f, 1f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("requested_rd")){
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),0f, 1f, 0f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0.8f);										
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),0f, 1f, 0f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("requested_inp")){
					//verifico che effetivamente siano presenti nela scena
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),1f, 0.5f, 0f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);															
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),1f, 0.5f, 0f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("requested_rdp")){
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),1f, 1f, 0f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);										
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),1f, 1f, 0f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("requested_setSpec")){
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),0.9f, 0.3f, 0f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0.8f);															
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),0.9f, 0.3f, 0f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("requested_getSpec")){
					myUniv.colorAgent(t2.getArg(1).getArg(1).toString(),0.7f, 0.7f, 0.7f);
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0.8f);															
					myUniv.colorTC(t2.getArg(1).getArg(0).toString(),0.7f, 0.7f, 0.7f);
					nomATemp=t2.getArg(1).getArg(1).toString();
					nomTCTemp=t2.getArg(1).getArg(0).toString();
					//Creo un nuovo oggetto per il movimento verificando che 
					//agente e tuple center siano presenti nela scena
					if (myUniv.userobject.containsKey(nomATemp)&myUniv.userobject.containsKey(nomTCTemp)){
						movea= new moveAgent(myUniv,(CadObject)myUniv.userobject.get(nomATemp),(CadObject)myUniv.userobject.get(nomTCTemp), listMovAgent);
						
					}
				}
				//se  un evento copleted rendo l'agente nitido (elimino la trasparenza)
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("completed_in")){
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);					
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("completed_rd")){
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);					
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("completed_setSpec")){
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);					
				}
				if (t2.getArg(1).getName().toString().equalsIgnoreCase("completed_getSpec")){
					myUniv.trasparenceAgent(t2.getArg(1).getArg(1).toString(),0f);					
				}
			} 
		} catch (TucsonException e) {
			System.out.println("Problemi con il tucson");
		} catch (LogicTupleException e1) {
			System.out.println("Problemi con le tuple");
		}

	}

}
