package view.Listener;

/**
 * Listener che viene collegato ai pick behaviour e viene lanciato ogni volta che c' stata una trasformazione 
 * attraverso il piking.
 * Per discriminare l'oggetto sul quale  avvenuta la trasformazione(e quindi l'oggetto da selezionare)
 * si confronta il tg passato durante la registrazione e quello che viene ricevuto dopo una modifica di picking.
 * 
 * @author Matteo Campana nmatr.0000197228
 */

import com.sun.j3d.utils.picking.behaviors.*;
import javax.media.j3d.*;
import javax.swing.*;
public class SelectionListener extends Object implements PickingCallback{
  private String nameSelected;//Nome da visualizzare quando si seleziona l'oggetto con una operazione di picking
  private TransformGroup tglocal;
  private JTextField nodeSField;//JTextField sul quale verr visualizzato il nome dell'oggetto selez
  
  /**
   * 
   * @param nom Riceve il nome da visualizzare quando si seleziona l'oggetto con una operazione di picking
   * @param tgoriginal Riceve il tg sul quale osservare le modiiche di piking che avvengono
   * @param nodeSelField Riceve il JTextField sul quale verr visualizzato il nome dell'oggetto selez
  */	
  public SelectionListener(String nom,TransformGroup tgoriginal, JTextField nodeSelField)
  {
	nameSelected=nom;
	tglocal=tgoriginal;
	nodeSField=nodeSelField;
  }
	
  public void transformChanged(int type, TransformGroup tg){
  	//Controllo se il tg da cui  stato lanciato  lo stesso dell'oggetto che ha lanciato il listener
	if (tglocal.equals(tg)){
		//Impongo il parametro statico della classe HostGui come il nome dell'oggetto "pikato"
		//cio inserisco nel JTextField dell'interfaccia grafica il nome del nodo selezionato
		nodeSField.setText(nameSelected);

  	}
  }

}